rm *.obj
rm *.exe
rm *.cpp
rm *.h
rm *.txt

$hidden_friend_vals = 0,1
$type_counts = 1,10,20,30,40,50
$self_comparisons = 1,10,20,30,40,50
foreach($hf in $hidden_friend_vals)
{
    foreach($type_count in $type_counts)
    {
        python gentypes.py -n $type_count -f $hf

        foreach($sc in $self_comparisons)
        {
            python genmain.py -n $type_count -s $sc -o 0

            # Run it twice before we take our timing to warm caches just in case
            cl -nologo -Od -c main.cpp
            cl -nologo -Od -c main.cpp
            $duration = Measure-Command { cl -nologo -Od -c main.cpp }
            $seconds = $duration.TotalSeconds
            echo "$sc,$seconds" | Out-File -Encoding utf8 -Append compile_seconds_msvc_${hf}_${type_count}.txt
            rm main.obj
        }
    }
}

